// Draw the Triangle
draw_set_color(c_white);
draw_triangle(x1, y1, x2, y2, x3, y3, true);

// Draw the Two Parts of the Collision Triangle Mask
// to Illustrate How the Full Triangle is Constructed
if (sprite_exists(__objCollisionTriangle.mask_index)) {
    var d12,d13,d23,t;
    // Find long side, make it (x1,y2) to (x2,y2)
    d12 = point_distance(x1,y1,x2,y2);
    d13 = point_distance(x1,y1,x3,y3);
    d23 = point_distance(x2,y2,x3,y3);
    switch (max(d12,d13,d23)) {
        case d13:
            t = x2; x2 = x3; x3 = t;
            t = y2; y2 = y3; y3 = t;
            d12 = d13;
            break;
        case d23:
            t = x1; x1 = x3; x3 = t;
            t = y1; y1 = y3; y3 = t;
            d12 = d23;
            break;
    }

    var dx,dy,x4,y4;
    // From (x3,y3), find nearest point on long side (x4,y4).
    dx = x2 - x1;
    dy = y2 - y1;
    if ((dx == 0) && (dy == 0)) {
        x4 = x1;
        y4 = y1;
    }else{
        t = ((x3 - x1) * dx + (y3 - y1) * dy) / (d12 * d12);
        x4 = x1 + t * dx;
        y4 = y1 + t * dy;
    }

    var d14,d24;
    var size = __objCollisionTriangle.size;

    // A line constructed from (x3,y3) to (x4,y4) divides
    // the original triangle into two right triangles.
    // Fit the collision mask into these triangles.
    d14 = point_distance(x1,y1,x4,y4);
    d24 = d12 - d14;

    var angle  = point_direction(x1,y1,x4,y4);
    var xscale = d14 / size;
    var yscale = point_distance(x3,y3,x4,y4) / size;
    if ((other.x1 > x4) ^^ (other.y3 < y4)) yscale *= -1;
    draw_sprite_ext(__objCollisionTriangle.mask_index,0,x4,y4,xscale,yscale,angle,#FF2266,0.5);
    xscale = -d24 / size;
    draw_sprite_ext(__objCollisionTriangle.mask_index,0,x4,y4,xscale,yscale,angle,#2266FF,0.5);
    
    draw_set_color(c_white);
    draw_triangle(x1, y1, x2, y2, x3, y3, true);
    draw_set_font(Font1);
    draw_text(20, 20, "Collision Mask Size: " + string(__objCollisionTriangle.size));
} else {
    draw_set_color(c_white);
    draw_set_font(Font1);
    draw_text(20,20,"ERROR: Missing collision mask");
}
